"
 COPYRIGHT (c) 1996-2011 by Claus Gittinger
 COPYRIGHT (c) 2010-2011 by Jan Vrany, Jan Kurs and Marcel Hlopko
                            SWING Research Group, Czech Technical University in Prague

 Parts of the code written by Claus Gittinger are under following
 license:

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.

 Parts of the code written at SWING Reasearch Group [1] are MIT licensed:

 Permission is hereby granted, free of charge, to any person
 obtaining a copy of this software and associated documentation
 files (the 'Software'), to deal in the Software without
 restriction, including without limitation the rights to use,
 copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the
 Software is furnished to do so, subject to the following
 conditions:

 The above copyright notice and this permission notice shall be
 included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 OTHER DEALINGS IN THE SOFTWARE.

 [1] Code written at SWING Research Group contain a signature
     of one of the above copright owners.
"
"{ Package: 'stx:libjava' }"

TestCase subclass:#JavaClassLoadingTests
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Languages-Java-Tests-ClassLoading'
!

!JavaClassLoadingTests class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 1996-2011 by Claus Gittinger
 COPYRIGHT (c) 2010-2011 by Jan Vrany, Jan Kurs and Marcel Hlopko
                            SWING Research Group, Czech Technical University in Prague

 Parts of the code written by Claus Gittinger are under following
 license:

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.

 Parts of the code written at SWING Reasearch Group [1] are MIT licensed:

 Permission is hereby granted, free of charge, to any person
 obtaining a copy of this software and associated documentation
 files (the 'Software'), to deal in the Software without
 restriction, including without limitation the rights to use,
 copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the
 Software is furnished to do so, subject to the following
 conditions:

 The above copyright notice and this permission notice shall be
 included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 OTHER DEALINGS IN THE SOFTWARE.

 [1] Code written at SWING Research Group contain a signature
     of one of the above copright owners.

"
! !

!JavaClassLoadingTests class methodsFor:'resources'!

resources
    ^ Array with: JavaFreshlyInitializedResource.

    "^ Array with: JavaFreshlyInitializedResource."
    "Created: / 12-10-2011 / 14:40:40 / Marcel Hlopko <hlopik@gmail.com>"
! !

!JavaClassLoadingTests methodsFor:'class reading'!

testGetCleanClassNameFromCleanClassName
    self 
        assertTrue: (JavaClassReader getCleanClassNameFrom: 'java.lang.Object') 
                = 'java/lang/Object'.
!

testGetCleanClassNameFromPrimitive
    self 
        assertTrue: (JavaClassReader getCleanClassNameFrom: '[[[D') 
                = 'D'.
!

testGetCleanClassNameFromSlashes
    self 
        assertTrue: (JavaClassReader getCleanClassNameFrom: 'java/lang/Object') 
                = 'java/lang/Object'.
!

testGetCleanClassNameFromWithArray
    self 
        assertTrue: (JavaClassReader getCleanClassNameFrom: '[Ljava/lang/Object;') 
                = 'java/lang/Object'.
!

testGetCleanClassNameFromWithInnerClass
    self 
        assertTrue: (JavaClassReader getCleanClassNameFrom: 'sun/misc/Launcher$Factory') 
                = 'sun/misc/Launcher$Factory'.
!

testGetCleanClassNameFromWithMultiarray
    self 
        assertTrue: (JavaClassReader 
                getCleanClassNameFrom: '[[[[Ljava/lang/Object;') = 'java/lang/Object'.
! !

!JavaClassLoadingTests methodsFor:'simple'!

testClassIsLoadedOnlyOnce
    self assertTrue: ((Java classForName: 'java.lang.String') 
                == (Java classForName: 'java.lang.String')).

    "Created: / 12-10-2011 / 14:44:12 / Marcel Hlopko <hlopik@gmail.com>"
!

testLoadingArray
    self assertTrue: ((Java classForName: '[Ljava.lang.Object;') notNil).

    "Created: / 12-10-2011 / 14:53:51 / Marcel Hlopko <hlopik@gmail.com>"
!

testLoadingArrayIsReallyArray
|loadedArray|
loadedArray := Java classForName: '[Ljava.lang.Object;'.
self assert: (loadedArray isJavaArrayClass).

    "Created: / 12-10-2011 / 14:55:52 / Marcel Hlopko <hlopik@gmail.com>"
!

testLoadingMultidimensionalArray
    self assertTrue: ((Java classForName: '[[[[[Ljava.lang.String;') notNil).

    "Created: / 12-10-2011 / 14:58:34 / Marcel Hlopko <hlopik@gmail.com>"
!

testLoadingObject
    self assertTrue: ((Java classForName: 'java.lang.Object') notNil).

    "Created: / 12-10-2011 / 14:42:34 / Marcel Hlopko <hlopik@gmail.com>"
!

testLoadingPrimitiveArray
    self assertTrue: ((Java classForName: '[I') notNil).

    "Created: / 12-10-2011 / 14:58:03 / Marcel Hlopko <hlopik@gmail.com>"
!

testLoadingPrimitiveMultidimensionalArray
    self assertTrue: ((Java classForName: '[[[[D') notNil).

    "Created: / 12-10-2011 / 14:58:17 / Marcel Hlopko <hlopik@gmail.com>"
!

testLoadingString
    self assertTrue: ((Java classForName: 'java.lang.String') notNil).

    "Created: / 12-10-2011 / 14:42:53 / Marcel Hlopko <hlopik@gmail.com>"
! !

!JavaClassLoadingTests class methodsFor:'documentation'!

version_SVN
    ^ '$Id$'
! !
