"
 COPYRIGHT (c) 1996-2011 by Claus Gittinger
 COPYRIGHT (c) 2010-2011 by Jan Vrany, Jan Kurs and Marcel Hlopko
                            SWING Research Group, Czech Technical University in Prague

 Parts of the code written by Claus Gittinger are under following
 license:

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.

 Parts of the code written at SWING Reasearch Group [1] are MIT licensed:

 Permission is hereby granted, free of charge, to any person
 obtaining a copy of this software and associated documentation
 files (the 'Software'), to deal in the Software without
 restriction, including without limitation the rights to use,
 copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the
 Software is furnished to do so, subject to the following
 conditions:

 The above copyright notice and this permission notice shall be
 included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 OTHER DEALINGS IN THE SOFTWARE.

 [1] Code written at SWING Research Group contain a signature
     of one of the above copright owners.
"
"{ Package: 'stx:libjava' }"

TestCase subclass:#SmalltalkSelectorParserTests
	instanceVariableNames:'p h'
	classVariableNames:''
	poolDictionaries:''
	category:'Languages-Java-Lookup-Tests'
!

!SmalltalkSelectorParserTests class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 1996-2011 by Claus Gittinger
 COPYRIGHT (c) 2010-2011 by Jan Vrany, Jan Kurs and Marcel Hlopko
                            SWING Research Group, Czech Technical University in Prague

 Parts of the code written by Claus Gittinger are under following
 license:

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.

 Parts of the code written at SWING Reasearch Group [1] are MIT licensed:

 Permission is hereby granted, free of charge, to any person
 obtaining a copy of this software and associated documentation
 files (the 'Software'), to deal in the Software without
 restriction, including without limitation the rights to use,
 copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the
 Software is furnished to do so, subject to the following
 conditions:

 The above copyright notice and this permission notice shall be
 included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 OTHER DEALINGS IN THE SOFTWARE.

 [1] Code written at SWING Research Group contain a signature
     of one of the above copright owners.

"
! !

!SmalltalkSelectorParserTests methodsFor:'running'!

setUp
    p := SmalltalkSelectorParser new.
    h := SampleHandler new.

    "Created: / 29-08-2011 / 23:19:12 / Jan Kurs <kursjan@fit.cvut.cz>"
!

testMethod
   |event|

   p parse: 'helloWorld' handler: h.
   self assert: h events size = 1.
   event := h events first.
   self assert: event first = #name.
   self assert: event second = 'helloWorld'.

    "Created: / 29-08-2011 / 23:19:28 / Jan Kurs <kursjan@fit.cvut.cz>"
!

testMethodWithArgs
   |event|

   p parse: 'helloWorld:' handler: h.
   self assert: h events size = 2.
   event := h events first.
   self assert: event first = #name.
   self assert: event second = 'helloWorld'.

   event := h events second.
   self assert: event first = #addArgumentOfType.
   self assert: event second isNil.

    "Created: / 29-08-2011 / 23:24:00 / Jan Kurs <kursjan@fit.cvut.cz>"
!

testMethodWithArgs2
   |event|

   p parse: 'helloWorld:with:' handler: h.
   self assert: h events size = 3.
   event := h events first.
   self assert: event first = #name.
   self assert: event second = 'helloWorld'.

   event := h events second.
   self assert: event first = #addArgumentOfType.
   self assert: event second isNil.

   event := h events third.
   self assert: event first = #addArgumentOfType.
   self assert: event second isNil.

    "Created: / 29-08-2011 / 23:23:54 / Jan Kurs <kursjan@fit.cvut.cz>"
!

testMethodWithArgs3
   |event|

   p parse: 'helloWorld:and:' handler: h.
   self assert: h events size = 3.
   event := h events first.
   self assert: event first = #name.
   self assert: event second = 'helloWorld'.

   event := h events second.
   self assert: event first = #addArgumentOfType.
   self assert: event second isNil.

   event := h events third.
   self assert: event first = #addArgumentOfType.
   self assert: event second isNil.

    "Created: / 29-08-2011 / 23:24:29 / Jan Kurs <kursjan@fit.cvut.cz>"
!

testMethodWithArgs4
   |event|

   p parse: 'helloWorld:and:with:' handler: h.
   self assert: h events size = 4.
   event := h events first.
   self assert: event first = #name.
   self assert: event second = 'helloWorld'.

   event := h events second.
   self assert: event first = #addArgumentOfType.
   self assert: event second isNil.

   event := h events third.
   self assert: event first = #addArgumentOfType.
   self assert: event second isNil.

   event := h events fourth.
   self assert: event first = #addArgumentOfType.
   self assert: event second isNil.

    "Created: / 29-08-2011 / 23:24:50 / Jan Kurs <kursjan@fit.cvut.cz>"
! !

!SmalltalkSelectorParserTests class methodsFor:'documentation'!

version_SVN
    ^ '$Id$'
! !
